var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _Task_task, _Task_promise, _Task_state, _TaskPromise_task, _TaskPromise_mapFn, _TaskPromise_mappedPromise, _a;
// deno-lint-ignore-file no-explicit-any
import { ResolvablePromise } from '@worker-tools/resolvable-promise';
import { pipe } from 'ts-functional-pipe';
const id = (_) => _;
class Task {
    constructor(task) {
        _Task_task.set(this, void 0);
        _Task_promise.set(this, void 0);
        _Task_state.set(this, 'idle');
        __classPrivateFieldSet(this, _Task_task, task, "f");
        __classPrivateFieldSet(this, _Task_promise, new ResolvablePromise(), "f");
    }
    execute() {
        if (__classPrivateFieldGet(this, _Task_state, "f") === 'idle') {
            __classPrivateFieldSet(this, _Task_state, 'pending', "f");
            __classPrivateFieldGet(this, _Task_promise, "f").resolve(__classPrivateFieldGet(this, _Task_task, "f").call(this));
            __classPrivateFieldGet(this, _Task_promise, "f").then(() => { __classPrivateFieldSet(this, _Task_state, 'fulfilled', "f"); }, () => { __classPrivateFieldSet(this, _Task_state, 'rejected', "f"); });
        }
    }
    get state() { return __classPrivateFieldGet(this, _Task_state, "f"); }
    get promise() { return __classPrivateFieldGet(this, _Task_promise, "f"); }
}
_Task_task = new WeakMap(), _Task_promise = new WeakMap(), _Task_state = new WeakMap();
const lock = Symbol('key');
// TODO: Make own module?
// TODO: Add abort signal?
// TODO: use executor instead of task functions?
// TODO: Remove TT type??
export class TaskPromise {
    constructor(key, task, mapFn, thisArg) {
        _TaskPromise_task.set(this, void 0);
        _TaskPromise_mapFn.set(this, void 0);
        _TaskPromise_mappedPromise.set(this, void 0);
        Object.defineProperty(this, _a, {
            enumerable: true,
            configurable: true,
            writable: true,
            value: 'TaskPromise'
        });
        if (key !== lock)
            throw Error('Illegal constructor');
        __classPrivateFieldSet(this, _TaskPromise_task, task, "f");
        __classPrivateFieldSet(this, _TaskPromise_mapFn, mapFn, "f");
        __classPrivateFieldSet(this, _TaskPromise_mappedPromise, __classPrivateFieldGet(this, _TaskPromise_task, "f").promise.then(mapFn && (x => mapFn.call(thisArg, x, 0, this))), "f");
    }
    static from(task) {
        return new TaskPromise(lock, new Task(task));
    }
    get state() {
        return __classPrivateFieldGet(this, _TaskPromise_task, "f").state;
    }
    /**
     * Starts the execution of the task associated with this task promise.
     * If you don't want to start the task at this moment, use `.map` instead.
     */
    then(onfulfilled, onrejected) {
        __classPrivateFieldGet(this, _TaskPromise_task, "f").execute();
        return __classPrivateFieldGet(this, _TaskPromise_mappedPromise, "f").then(onfulfilled, onrejected);
    }
    /**
     * Applies transformations to the resolved value without triggering execution.
     * Returns another task promise that triggers execution via `.then`
     */
    map(mapFn, thisArg) {
        var _b;
        // @ts-ignore: types of id function (x => x) not correctly inferred...
        return new TaskPromise(lock, __classPrivateFieldGet(this, _TaskPromise_task, "f"), pipe((_b = __classPrivateFieldGet(this, _TaskPromise_mapFn, "f")) !== null && _b !== void 0 ? _b : id, mapFn !== null && mapFn !== void 0 ? mapFn : id), thisArg);
    }
    catch(onrejected) {
        // FIXME: should this also trigger execution?
        return __classPrivateFieldGet(this, _TaskPromise_mappedPromise, "f").catch(onrejected);
    }
    finally(onfinally) {
        // FIXME: should this also trigger execution?
        return __classPrivateFieldGet(this, _TaskPromise_mappedPromise, "f").finally(onfinally);
    }
}
_TaskPromise_task = new WeakMap(), _TaskPromise_mapFn = new WeakMap(), _TaskPromise_mappedPromise = new WeakMap(), _a = Symbol.toStringTag;
//# sourceMappingURL=task-promise.js.map