import { StreamResponse, StreamRequest } from "@worker-tools/stream-response";
export declare type JSONStreamBodyInit = ReadableStream<string> | AsyncIterable<string> | any;
export declare type JSONStreamRequestInit = Omit<RequestInit, 'body'> & {
    body?: JSONStreamBodyInit;
};
export declare class JSONStreamRequest extends StreamRequest {
    static contentType: string;
    static accept: string;
    constructor(input: RequestInfo | URL, init?: JSONStreamRequestInit);
}
export declare class JSONStreamResponse extends StreamResponse {
    static contentType: string;
    constructor(body?: JSONStreamBodyInit | null, init?: ResponseInit);
}
